import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
import * as wjFlexSheet from '@mescius/wijmo.grid.sheet';
import { getData, getCountries, getProducts } from './data';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
let sortSheet = new wjFlexSheet.FlexSheet('#sortSheet');
sortSheet.addBoundSheet('Country', getData(50));
sortSheet.deferUpdate(() => {
let column = sortSheet.columns.getColumn('countryId');
if (column && !column.dataMap) {
column.dataMap = buildDataMap(getCountries());
}
column = sortSheet.columns.getColumn('productId');
if (column && !column.dataMap) {
column.dataMap = buildDataMap(getProducts());
}
column = sortSheet.columns.getColumn('amount');
if (column) {
column.format = 'c2';
}
});
let sortManager = sortSheet.sortManager;
updateSortTable();
onClick('addLevel', addSortLevel);
onClick('delLevel', deleteSortLevel);
onClick('copyLevel', copySortLevel);
onClick('moveup', () => {
moveSortLevel(-1);
});
onClick('movedown', () => {
moveSortLevel(1);
});
onClick('commitSort', commitSort);
onClick('cancelSort', cancelSort);
sortSheet.selectedSheetChanged.addHandler(() => {
updateSortTable();
});
sortManager.sortDescriptions.collectionChanged.addHandler(() => {
updateSortTable();
});
sortManager.sortDescriptions.currentChanged.addHandler(() => {
updateSortTable();
});
function updateSortTable() {
let sortTableBody = document.querySelector('#sortTable tbody'), tRows = '', columns = getColumns();
for (let index = 0; index < sortManager.sortDescriptions.itemCount; index++) {
let sortItem = sortManager.sortDescriptions.items[index];
tRows += '<tr class="' + (sortManager.sortDescriptions.currentPosition === index ? 'success"' : '"') + '><td>' + updateColumnSelect(columns, sortItem) + '</td>';
tRows += '<td><select class="form-control" onchange=""><option value="0"' + ((!sortItem || sortItem.ascending) ? ' selected="selected">' : '>') + 'Ascending</option>' +
'<option value="1"' + ((sortItem && !sortItem.ascending) ? ' selected="selected">' : '>') + 'Descending</option></select></td></tr>';
}
sortTableBody.innerHTML = tRows;
let sortRows = sortTableBody.querySelectorAll('tr');
for (let rowIndex = 0; rowIndex < sortRows.length; rowIndex++) {
sortRows[rowIndex].addEventListener('click', () => {
sortManager.sortDescriptions.moveCurrentToPosition(rowIndex);
updateActiveRow();
});
}
let columnSelects = sortTableBody.querySelectorAll('tr td:first-child select'), ascendingSelects = sortTableBody.querySelectorAll('tr td:last-child select');
for (let sortIndex = 0; sortIndex < columnSelects.length; sortIndex++) {
let sortItem = sortManager.sortDescriptions.items[sortIndex];
columnSelects[sortIndex].addEventListener('change', e => {
sortItem.columnIndex = e.target.selectedIndex - 1;
});
ascendingSelects[sortIndex].addEventListener('change', e => {
sortItem.ascending = e.target.selectedIndex === 0;
});
}
updateMoveButtonState();
}
function updateActiveRow() {
let sortTableBody = document.querySelector('#sortTable tbody'), sortRows = sortTableBody.querySelectorAll('tr');
removeSuccessClass(sortRows);
wjCore.addClass(sortRows[sortManager.sortDescriptions.currentPosition], 'success');
}
function removeSuccessClass(sortRows) {
for (let rowIndex = 0; rowIndex < sortRows.length; rowIndex++) {
wjCore.removeClass(sortRows[rowIndex], 'success');
}
}
function updateColumnSelect(columns, sortItem) {
let colSelect = '<select class="form-control"><option value=-1></option>';
for (let index = 0; index < columns.length; index++) {
colSelect += '<option ' + ((sortItem && sortItem.columnIndex === index) ? 'selected="selected" ' : '') + ' value="' + index + '">' + columns[index] + '</option>';
}
colSelect += '</select>';
return colSelect;
}
function updateMoveButtonState() {
let moveupBtn = document.querySelector('#moveup'), movedownBtn = document.querySelector('#movedown');
if (sortManager.sortDescriptions.currentPosition === 0) {
moveupBtn.setAttribute('disabled', 'true');
}
else {
moveupBtn.removeAttribute('disabled');
}
if (sortManager.sortDescriptions.currentPosition === sortManager.sortDescriptions.itemCount - 1) {
movedownBtn.setAttribute('disabled', 'true');
}
else {
movedownBtn.removeAttribute('disabled');
}
}
// get the columns with the column header text for the column selection for sort setting.
function getColumns() {
var columns = [], i = 0;
if (sortSheet) {
for (; i < sortSheet.columns.length; i++) {
columns.push('Column ' + wjFlexSheet.FlexSheet.convertNumberToAlpha(i));
}
}
return columns;
}
// commit the sorts
function commitSort() {
sortManager.commitSort();
}
// cancel the sorts
function cancelSort() {
sortManager.cancelSort();
updateActiveRow();
}
// add new sort level
function addSortLevel() {
sortManager.addSortLevel();
updateActiveRow();
}
// delete current sort level
function deleteSortLevel() {
sortManager.deleteSortLevel();
updateActiveRow();
}
// copy a new sort level by current sort level setting.
function copySortLevel() {
sortManager.copySortLevel();
updateActiveRow();
}
// move the sort level
function moveSortLevel(offset) {
sortManager.moveSortLevel(offset);
updateActiveRow();
}
// build a data map from a string array using the indices as keys
function buildDataMap(items) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjGrid.DataMap(map, 'key', 'value');
}
;
function onClick(id, fn) {
document.querySelector('#' + id).addEventListener('click', fn);
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexSheet Sorting</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<div id="sortSheet"></div>
<table id="sortTable" class="table table-bordered">
<thead>
<tr>
<th class="text-center">Column</th>
<th class="text-center">Order</th>
</tr>
</thead>
<tbody>
</tbody>
</table>
<div class="btn-group">
<button id="addLevel" type="button" class="btn btn-default">
Add Level
</button>
<button id="delLevel" type="button" class="btn btn-default">
Delete Level
</button>
<button id="copyLevel" type="button" class="btn btn-default">
Copy Level
</button>
</div>
<div class="btn-group">
<button id="moveup" type="button"
class="btn btn-default">
<span class="glyphicon glyphicon-arrow-up"></span>
</button>
<button id="movedown" type="button"
class="btn btn-default">
<span class="glyphicon glyphicon-arrow-down"></span>
</button>
</div>
<div class="btn-group">
<button id="commitSort" type="button" class="btn btn-default">OK</button>
<button id="cancelSort" type="button" class="btn btn-default">Cancel</button>
</div>
</div>
</body>
</html>
let countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'], products = ['Widget', 'Gadget', 'Doohickey'];
export function getData(count) {
let data = [], i = 0, countryId, productId;
for (; i < count; i++) {
countryId = Math.floor(Math.random() * countries.length);
productId = Math.floor(Math.random() * products.length);
data.push({
id: i,
countryId: countryId,
productId: productId,
date: new Date(2014, i % 12, i % 28),
amount: Math.random() * 10000,
active: i % 4 === 0
});
}
return data;
}
export function getCountries() {
return countries;
}
export function getProducts() {
return products;
}
.wj-flexsheet {
height: 400px;
margin: 6px 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjcSheet from '@mescius/wijmo.grid.sheet';
import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjGridSheet from '@mescius/wijmo.react.grid.sheet';
import './app.css';
import { data, countries, products } from './data';
function App() {
const [sortManager, setSortManager] = useState(null);
const [columns, setColumns] = useState([]);
const [time, setTime] = useState(0);
const initializeFlexSheet = useEvent((flex) => {
flex.deferUpdate(() => {
let column = flex.columns.getColumn("countryId");
if (column && !column.dataMap) {
column.dataMap = buildDataMap(countries);
}
column = flex.columns.getColumn("productId");
if (column && !column.dataMap) {
column.width = 100;
column.dataMap = buildDataMap(products);
}
column = flex.columns.getColumn("amount");
if (column) {
column.format = "c2";
}
setSortManager(flex.sortManager);
setColumns(getColumns(flex));
});
flex.selectedSheetChanged.addHandler(() => {
setColumns(getColumns(flex));
if (!sortManager) {
setSortManager(flex.sortManager);
}
});
flex.columnChanged.addHandler(() => {
setColumns(getColumns(flex));
});
flex.sortManager.sortDescriptions.collectionChanged.addHandler(() => {
forceUpdate();
});
});
// commit the sorts
const commitSort = () => {
sortManager.commitSort();
forceUpdate();
};
// cancel the sorts
const cancelSort = () => {
sortManager.cancelSort();
forceUpdate();
};
// add new sort level
const addSortLevel = () => {
sortManager.addSortLevel();
forceUpdate();
};
// delete current sort level
const deleteSortLevel = () => {
sortManager.deleteSortLevel();
forceUpdate();
};
// copy a new sort level by current sort level setting.
const copySortLevel = () => {
sortManager.copySortLevel();
forceUpdate();
};
// move the sort level
const moveSortLevel = (offset) => {
sortManager.moveSortLevel(offset);
forceUpdate();
};
// apply column index property for sort item
const applySortColumnIndex = (e, sortItem) => {
sortItem.columnIndex = e.target.value;
};
// apply asceding property for sort item
const applySortAscending = (e, sortItem) => {
if (e.target.value === "true") {
sortItem.ascending = true;
}
else {
sortItem.ascending = false;
}
};
// build a data map from a string array using the indices as keys
const buildDataMap = (items) => {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjcGrid.DataMap(map, "key", "value");
};
const getColumns = (flexSheet) => {
let columns = [], i = 0;
if (flexSheet) {
for (; i < flexSheet.columns.length; i++) {
columns.push("Column " + wjcSheet.FlexSheet.convertNumberToAlpha(i));
}
}
return columns;
};
const renderOption = (sortItem, column, i) => {
return (<option key={i} selected={(i === sortItem.columnIndex)} value={i}>{column}</option>);
};
const getClass = (sortItem) => {
let flag = (sortItem === sortManager.sortDescriptions.currentItem);
if (flag) {
return "success";
}
return "";
};
const onTrClick = (sortItem) => {
sortManager.sortDescriptions.moveCurrentTo(sortItem);
forceUpdate();
};
const renderTr = (sortItem, i) => {
const option = columns.map((column, i) => renderOption(sortItem, column, i));
return (<tr key={i} onClick={() => onTrClick(sortItem)} className={getClass(sortItem)}>
<td>
<select className="form-control" onChange={(e) => applySortColumnIndex(e, sortItem)}>
<option value="-1"></option>
{option}
</select>
</td>
<td>
<select className="form-control" onChange={(e) => applySortAscending(e, sortItem)}>
<option value="true" selected={sortItem.ascending}>Ascending</option>
<option value="false" selected={!sortItem.ascending}>Descending</option>
</select>
</td>
</tr>);
};
const renderTbody = () => {
if (!sortManager) {
return;
}
const rows = sortManager.sortDescriptions.items.map((sortItem, i) => renderTr(sortItem, i));
return (<tbody>
{rows}
</tbody>);
};
const forceUpdate = () => {
setTime(new Date().getTime());
};
return (<div className="container-fluid">
<wjGridSheet.FlexSheet initialized={initializeFlexSheet}>
<wjGridSheet.Sheet name="Country" itemsSource={data}/>
</wjGridSheet.FlexSheet>
<table className="table table-bordered">
<thead>
<tr>
<th className="text-center" style={{ width: "50%" }}>Column</th>
<th className="text-center" style={{ width: "50%" }}>Order</th>
</tr>
</thead>
{renderTbody()}
</table>
<div className="btn-group">
<button type="button" className="btn btn-default" onClick={addSortLevel}>Add Level</button>
<button type="button" className="btn btn-default" onClick={deleteSortLevel}>Delete Level</button>
<button type="button" className="btn btn-default" onClick={copySortLevel}>Copy Level</button>
</div>
<div className="btn-group">
<button id="moveup" type="button" className="btn btn-default" disabled={sortManager && sortManager.sortDescriptions.currentPosition <= 0} onClick={() => moveSortLevel(-1)}>
<span className="glyphicon glyphicon-arrow-up"></span>
</button>
<button id="movedown" type="button" className="btn btn-default" disabled={sortManager && sortManager.sortDescriptions.currentPosition >= sortManager.sortDescriptions.itemCount - 1} onClick={() => moveSortLevel(1)}>
<span className="glyphicon glyphicon-arrow-down"></span>
</button>
</div>
<div className="btn-group">
<button type="button" className="btn btn-default" onClick={commitSort}>OK</button>
<button type="button" className="btn btn-default" onClick={cancelSort}>Cancel</button>
</div>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexSheet Sorting</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.container-fluid .wj-flexsheet {
height: 400px;
margin: 6px 0;
}
function getData(count) {
let data = [], i = 0, countryId, productId;
for (; i < count; i++) {
countryId = Math.floor(Math.random() * countries.length);
productId = Math.floor(Math.random() * products.length);
data.push({
id: i,
countryId: countryId,
productId: productId,
date: new Date(2014, i % 12, i % 28),
amount: Math.random() * 10000,
active: i % 4 === 0
});
}
return data;
}
export const countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
export const products = ['Widget', 'Gadget', 'Doohickey'];
export const data = getData(50);
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import '@angular/compiler';
import { Component, enableProdMode, Inject, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridSheetModule } from '@mescius/wijmo.angular2.grid.sheet';
import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcSheet from '@mescius/wijmo.grid.sheet';
import { DataService } from './app.data';
@Component({
standalone: true,
providers: [DataService],
imports: [WjGridSheetModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
data: any[];
sortManager: wjcSheet.SortManager;
columns: string[];
private _countries: string[];
private _products: string[];
constructor(@Inject(DataService) dataSvc: DataService) {
this.data = dataSvc.getData(50);
this._countries = dataSvc.countries;
this._products = dataSvc.products;
}
initializeFlexSheet(flex: wjcSheet.FlexSheet) {
flex.deferUpdate(() => {
let column = flex.columns.getColumn('countryId');
if (column && !column.dataMap) {
column.dataMap = this._buildDataMap(this._countries);
}
column = flex.columns.getColumn('productId');
if (column && !column.dataMap) {
column.width = 100;
column.dataMap = this._buildDataMap(this._products);
}
column = flex.columns.getColumn('amount');
if (column) {
column.format = 'c2';
}
this.sortManager = flex.sortManager;
this.columns = this._getColumns(flex);
});
flex.selectedSheetChanged.addHandler(() => {
this.columns = this._getColumns(flex);
if (!this.sortManager) {
this.sortManager = flex.sortManager;
}
});
flex.columnChanged.addHandler(() => {
this.columns = this._getColumns(flex);
});
}
// commit the sorts
commitSort() {
this.sortManager.commitSort();
}
// cancel the sorts
cancelSort() {
this.sortManager.cancelSort();
}
// add new sort level
addSortLevel() {
this.sortManager.addSortLevel();
}
// delete current sort level
deleteSortLevel() {
this.sortManager.deleteSortLevel();
}
// copy a new sort level by current sort level setting.
copySortLevel() {
this.sortManager.copySortLevel();
}
// move the sort level
moveSortLevel(offset: number) {
this.sortManager.moveSortLevel(offset);
}
// apply column index property for sort item
applySortColumnIndex(e: any, sortItem: wjcSheet.ColumnSortDescription) {
sortItem.columnIndex = +e.target.value;
}
// apply asceding property for sort item
applySortAscending(e: any, sortItem: wjcSheet.ColumnSortDescription) {
if (e.target.value === 'true') {
sortItem.ascending = true;
} else {
sortItem.ascending = false;
}
}
// build a data map from a string array using the indices as keys
private _buildDataMap(items: string[]) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjcGrid.DataMap(map, 'key', 'value');
}
private _getColumns(flexSheet: wjcSheet.FlexSheet): string[] {
let columns = [],
i = 0;
if (flexSheet) {
for (; i < flexSheet.columns.length; i++) {
columns.push('Column ' + wjcSheet.FlexSheet.convertNumberToAlpha(i));
}
}
return columns;
}
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexSheet Sorting</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<!-- the flexsheet -->
<wj-flex-sheet #flex
(initialized)="initializeFlexSheet(flex)">
<wj-sheet [name]="'Country'" [(itemsSource)]="data"></wj-sheet>
</wj-flex-sheet>
<table class="table table-bordered">
<thead>
<tr>
<th class="text-center" style="width: 50%;">Column</th>
<th class="text-center" style="width: 50%;">Order</th>
</tr>
</thead>
<tbody *ngIf="sortManager">
<tr *ngFor="let sortItem of sortManager.sortDescriptions.items"
(click)="sortManager.sortDescriptions.moveCurrentTo(sortItem)"
[ngClass]="{success: sortItem === sortManager.sortDescriptions.currentItem}">
<td>
<select class="form-control" (change)="applySortColumnIndex($event, sortItem)">
<option value=-1></option>
<option *ngFor="let column of columns; let i = index" [selected]="i === sortItem.columnIndex"
value={{i}}>
{{column}}
</option>
</select>
</td>
<td>
<select class="form-control" (change)="applySortAscending($event, sortItem)">
<option [value]="true" [selected]="sortItem.ascending">Ascending</option>
<option [value]="false" [selected]="!sortItem.ascending">Descending</option>
</select>
</td>
</tr>
</tbody>
</table>
<div class="btn-group">
<button type="button" class="btn btn-default" (click)="addSortLevel()">
Add Level
</button>
<button type="button" class="btn btn-default" (click)="deleteSortLevel()">
Delete Level
</button>
<button type="button" class="btn btn-default" (click)="copySortLevel()">
Copy Level
</button>
</div>
<div class="btn-group">
<button id="moveup" type="button"
class="btn btn-default"
[disabled]="sortManager && sortManager.sortDescriptions.currentPosition <= 0"
(click)="moveSortLevel(-1)">
<span class="glyphicon glyphicon-arrow-up"></span>
</button>
<button id="movedown" type="button"
class="btn btn-default"
[disabled]="sortManager && sortManager.sortDescriptions.currentPosition >= sortManager.sortDescriptions.itemCount - 1"
(click)="moveSortLevel(1)">
<span class="glyphicon glyphicon-arrow-down"></span>
</button>
</div>
<div class="btn-group">
<button type="button" class="btn btn-default" (click)="commitSort()">OK</button>
<button type="button" class="btn btn-default" (click)="cancelSort()">Cancel</button>
</div>
</div>
import { Injectable } from '@angular/core';
@Injectable()
export class DataService {
countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
products = ['Widget', 'Gadget', 'Doohickey'];
getData(count: number) {
let data = [],
i = 0,
countryId,
productId;
for (; i < count; i++) {
countryId = Math.floor(Math.random() * this.countries.length);
productId = Math.floor(Math.random() * this.products.length);
data.push({
id: i,
countryId: countryId,
productId: productId,
date: new Date(2014, i % 12, i % 28),
amount: Math.random() * 10000,
active: i % 4 === 0
});
}
return data;
}
}
.wj-flexsheet {
height: 400px;
margin: 6px 0;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

<template>
<div class="container-fluid">
<!-- the flexsheet -->
<wj-flex-sheet :initialized="initializeFlexSheet">
<wj-sheet :name="'Country'" :itemsSource="data"></wj-sheet>
</wj-flex-sheet>
<table class="table table-bordered">
<thead>
<tr>
<th class="text-center" style="width: 50%;">Column</th>
<th class="text-center" style="width: 50%;">Order</th>
</tr>
</thead>
<tbody v-if="sortManager">
<tr v-for="(sortItem, index) of sortManager.sortDescriptions.items" :key="index"
@click="sortManager.sortDescriptions.moveCurrentTo(sortItem)"
:class="{ success: sortItem === sortManager.sortDescriptions.currentItem }">
<td>
<select class="form-control" @change="applySortColumnIndex($event, sortItem)">
<option value="-1"></option>
<option v-for="(column, i) of columns" :key="i" :selected="i === sortItem.columnIndex"
:value="i">{{ column }}</option>
</select>
</td>
<td>
<select class="form-control" @change="applySortAscending($event, sortItem)">
<option :value="true" :selected="sortItem.ascending">Ascending</option>
<option :value="false" :selected="!sortItem.ascending">Descending</option>
</select>
</td>
</tr>
</tbody>
</table>
<div class="btn-group">
<button type="button" class="btn btn-default" @click="addSortLevel">Add Level</button>
<button type="button" class="btn btn-default" @click="deleteSortLevel">Delete Level</button>
<button type="button" class="btn btn-default" @click="copySortLevel">Copy Level</button>
</div>
<div class="btn-group">
<button id="moveup" type="button" class="btn btn-default"
:disabled="sortManager && sortManager.sortDescriptions.currentPosition <= 0" @click="moveSortLevel(-1)">
<span class="glyphicon glyphicon-arrow-up"></span>
</button>
<button id="movedown" type="button" class="btn btn-default"
:disabled="sortManager && sortManager.sortDescriptions.currentPosition >= sortManager.sortDescriptions.itemCount - 1"
@click="moveSortLevel(1)">
<span class="glyphicon glyphicon-arrow-down"></span>
</button>
</div>
<div class="btn-group">
<button type="button" class="btn btn-default" @click="commitSort">OK</button>
<button type="button" class="btn btn-default" @click="cancelSort">Cancel</button>
</div>
</div>
</template>
<script setup>
import * as wjcGrid from "@mescius/wijmo.grid";
import * as wjcSheet from "@mescius/wijmo.grid.sheet";
import { getData, getCountries, getProducts } from "./data";
import { ref } from "vue";
const data = ref(getData(50));
const sortManager = ref(null);
const columns = ref([]);
const countries = ref(getCountries());
const products = ref(getProducts());
function initializeFlexSheet(flex) {
flex.deferUpdate(() => {
let column = flex.columns.getColumn("countryId");
if (column && !column.dataMap) {
column.dataMap = _buildDataMap(countries.value);
}
column = flex.columns.getColumn("productId");
if (column && !column.dataMap) {
column.width = 100;
column.dataMap = _buildDataMap(products.value);
}
column = flex.columns.getColumn("amount");
if (column) {
column.format = "c2";
}
sortManager.value = flex.sortManager;
columns.value = _getColumns(flex);
});
flex.selectedSheetChanged.addHandler(() => {
columns.value = _getColumns(flex);
if (!sortManager.value) {
sortManager.value = flex.sortManager;
}
});
flex.columnChanged.addHandler(() => {
columns.value = _getColumns(flex);
});
}
function commitSort() {
sortManager.value.commitSort();
}
function cancelSort() {
sortManager.value.cancelSort();
}
function addSortLevel() {
sortManager.value.addSortLevel();
}
function deleteSortLevel() {
sortManager.value.deleteSortLevel();
}
function copySortLevel() {
sortManager.value.copySortLevel();
}
function moveSortLevel(offset) {
sortManager.value.moveSortLevel(offset);
}
function applySortColumnIndex(e, sortItem) {
sortItem.columnIndex = e.target.value;
}
function applySortAscending(e, sortItem) {
if (e.target.value === "true") {
sortItem.ascending = true;
} else {
sortItem.ascending = false;
}
}
function _buildDataMap(items) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjcGrid.DataMap(map, "key", "value");
}
function _getColumns(flexSheet) {
let columns = [],
i = 0;
if (flexSheet) {
for (; i < flexSheet.columns.length; i++) {
columns.push("Column " + wjcSheet.FlexSheet.convertNumberToAlpha(i));
}
}
return columns;
}
</script>
<style>
.container-fluid .wj-flexsheet {
height: 400px;
margin: 6px 0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexSheet Sorting</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="node_modules/jszip/dist/jszip.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
let countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'], products = ['Widget', 'Gadget', 'Doohickey'];
export function getData(count) {
let data = [], i = 0, countryId, productId;
for (; i < count; i++) {
countryId = Math.floor(Math.random() * countries.length);
productId = Math.floor(Math.random() * products.length);
data.push({
id: i,
countryId: countryId,
productId: productId,
date: new Date(2014, i % 12, i % 28),
amount: Math.random() * 10000,
active: i % 4 === 0
});
}
return data;
}
export function getCountries() {
return countries;
}
export function getProducts() {
return products;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);